//
//  MedicationTableViewController.m
//  kid_peak_flow
//
//  Created by smenesid on 5/11/13.
//  Copyright (c) 2013 mixalis menesidis. All rights reserved.
//

#import "MedicationTableViewController.h"
#import "ECSlidingViewController.h"
#import "SlideMenuViewController.h"
#import "FormKit.h"
#import "Asthma.h"
#import "Comment.h"
#import "Genre.h"
#import "BWLongTextViewController.h"
#import "database.h"
#import "sqlite3.h"
#import "SimplePost.h"
#import "Task.h"

@interface MedicationTableViewController ()

@end

@implementation MedicationTableViewController

@synthesize slideMenuBtn;
@synthesize formModel;

@synthesize saveButton;
@synthesize asth_attack = _movie;
@synthesize db;

static NSString *kAddTask = @"http://192.168.1.107/my_tasks/add_task.php";


- (void)viewDidLoad
{
    [super viewDidLoad];

    self.formModel = [FKFormModel formTableModelForTableView:self.tableView
                                        navigationController:self.navigationController];
    
    Asthma *movie = [Asthma movieWithTitle:@"Farmako1"
                                 content:@""];
    
    
   // movie.dose = [NSNumber numberWithFloat:2];
    
    // SELECT APO TIN VASH
    db = [[database alloc] init];
    movie.inputmedication =[db selectFromTableNSString:@"inputmedication":@"medicationTable"];
    movie.dose = [db selectFromTableNSNumber:@"dose" :@"medicationTable"];
    movie.inputmedication2 = [db selectFromTableNSString:@"inputmedication2" :@"medicationTable"];
    movie.dose2 = [db selectFromTableNSNumber:@"dose2" :@"medicationTable"];
    movie.inputmedication3 = [db selectFromTableNSString:@"inputmedication3" :@"medicationTable"];
    movie.dose3 = [db selectFromTableNSNumber:@"dose3" :@"medicationTable"];
    
    self.asth_attack = movie;
    
    [FKFormMapping mappingForClass:[Asthma class] block:^(FKFormMapping *formMapping) {
        [formMapping sectionWithTitle:@"" footer:@"" identifier:@"info1"];
        [formMapping mapAttribute:@"inputmedication" title:@"Input Medication" type:FKFormAttributeMappingTypeText];
        [formMapping mapAttribute:@"dose" title:@"Dose per day" type:FKFormAttributeMappingTypeInteger];
        [formMapping mapAttribute:@"inputmedication2" title:@"Input Medication2" type:FKFormAttributeMappingTypeText];
        [formMapping mapAttribute:@"dose2" title:@"Dose per day2" type:FKFormAttributeMappingTypeInteger];
        [formMapping mapAttribute:@"inputmedication3" title:@"Input Medication3" type:FKFormAttributeMappingTypeText];
        [formMapping mapAttribute:@"dose3" title:@"Dose per day3" type:FKFormAttributeMappingTypeInteger];

        
        [formMapping validationForAttribute:@"title" validBlock:^BOOL(NSString *value, id object) {
            return value.length < 30;
            
        } errorMessageBlock:^NSString *(id value, id object) {
            return @"Text is too long.";
        }];
        
        [formMapping validationForAttribute:@"releaseDate" validBlock:^BOOL(id value, id object) {
            return NO;
        }];
        
        [self.formModel registerMapping:formMapping];
    }];
    
    [self.formModel setDidChangeValueWithBlock:^(id object, id value, NSString *keyPath) {
        NSLog(@"did change model value");
    }];
    
    [self.formModel loadFieldsWithObject:movie];
    
    
    self.view.layer.shadowOpacity = 0.75f;
    self.view.layer.shadowRadius = 10.0f;
    self.view.layer.shadowColor = [UIColor blackColor].CGColor;
    
    
    if (![self.slidingViewController.underLeftViewController isKindOfClass:[SlideMenuViewController class]]) {
        self.slidingViewController.underLeftViewController  = [self.storyboard instantiateViewControllerWithIdentifier:@"SlideMenu"];
    }
    
    self.slideMenuBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    slideMenuBtn.frame = CGRectMake(8, 10, 34, 24);
    [slideMenuBtn setBackgroundImage:[UIImage imageNamed:@"Button.png"] forState:UIControlStateNormal];
    [slideMenuBtn addTarget:self action:@selector(revealMenu:) forControlEvents:UIControlEventTouchUpInside];
    
    
    [self.view addSubview:self.slideMenuBtn];
    
    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
    
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
    
    
    [[self navigationController] setNavigationBarHidden:NO animated:NO];
    
    
    saveButton = [[UIBarButtonItem alloc]initWithTitle:@"Save" style:UIBarButtonItemStyleBordered target:self action:@selector(saveEntry:)];
    
    [self.navigationController.navigationBar.topItem setTitle:@"Medication"];
    
    [self.navigationController.navigationBar.topItem setRightBarButtonItem:saveButton];

}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
#warning Potentially incomplete method implementation.
    // Return the number of sections.
    return 0;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
#warning Incomplete method implementation.
    // Return the number of rows in the section.
    return 0;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    
    // Configure the cell...
    
    return cell;
}
 

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/

/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:@[indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/

/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}
*/

/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     */
     
}


////////////////////////////////////////////////////////////////////////////////////////////////////
- (void)viewDidUnload {
    [super viewDidUnload];
    
    self.formModel = nil;
    self.asth_attack = nil;
}
- (IBAction)revealMenu:(id)sender
{
    [self.slidingViewController anchorTopViewTo:ECRight];
}
-(IBAction)saveEntry:(id)sender{
    
    db = [[database alloc] init];
    //[db updateMedication:self.asth_attack.inputmedication :self.asth_attack.dose];
    [db updateMedication:self.asth_attack.inputmedication :self.asth_attack.dose :self.asth_attack.inputmedication2 :self.asth_attack.dose2 :self.asth_attack.inputmedication3 :self.asth_attack.dose3];
    
    ////
    Task *userID = [[Task alloc] initWithName:@"1"];
    NSMutableURLRequest *request_userID = [SimplePost urlencodedRequestWithURL:[NSURL URLWithString:kAddTask] andDataDictionary:[userID toDictionary:@"userID"]];
    [[NSURLConnection alloc] initWithRequest:request_userID delegate:self];
    
    Task *inputmedication = [[Task alloc] initWithName:self.asth_attack.inputmedication];
    NSMutableURLRequest *request_inputmedication = [SimplePost urlencodedRequestWithURL:[NSURL URLWithString:kAddTask] andDataDictionary:[inputmedication toDictionary:@"inputmedication"]];
    [[NSURLConnection alloc] initWithRequest:request_inputmedication delegate:self];

    NSString *sdose = [NSString stringWithFormat:@"%@", self.asth_attack.dose];
    Task *dose = [[Task alloc] initWithName:sdose];
    NSMutableURLRequest *request_dose = [SimplePost urlencodedRequestWithURL:[NSURL URLWithString:kAddTask] andDataDictionary:[dose toDictionary:@"dose"]];
    [[NSURLConnection alloc] initWithRequest:request_dose delegate:self];
    
    Task *inputmedication2 = [[Task alloc] initWithName:self.asth_attack.inputmedication2];
    NSMutableURLRequest *request_inputmedication2 = [SimplePost urlencodedRequestWithURL:[NSURL URLWithString:kAddTask] andDataDictionary:[inputmedication2 toDictionary:@"inputmedication2"]];
    [[NSURLConnection alloc] initWithRequest:request_inputmedication2 delegate:self];
    
    NSString *sdose2 = [NSString stringWithFormat:@"%@", self.asth_attack.dose2];
    Task *dose2 = [[Task alloc] initWithName:sdose2];
    NSMutableURLRequest *request_dose2 = [SimplePost urlencodedRequestWithURL:[NSURL URLWithString:kAddTask] andDataDictionary:[dose2 toDictionary:@"dose2"]];
    [[NSURLConnection alloc] initWithRequest:request_dose2 delegate:self];

    Task *inputmedication3 = [[Task alloc] initWithName:self.asth_attack.inputmedication3];
    NSMutableURLRequest *request_inputmedication3 = [SimplePost urlencodedRequestWithURL:[NSURL URLWithString:kAddTask] andDataDictionary:[inputmedication3 toDictionary:@"inputmedication3"]];
    [[NSURLConnection alloc] initWithRequest:request_inputmedication3 delegate:self];
    
    NSString *sdose3 = [NSString stringWithFormat:@"%@", self.asth_attack.dose3];
    Task *dose3 = [[Task alloc] initWithName:sdose3];
    NSMutableURLRequest *request_dose3 = [SimplePost urlencodedRequestWithURL:[NSURL URLWithString:kAddTask] andDataDictionary:[dose3 toDictionary:@"dose3"]];
    [[NSURLConnection alloc] initWithRequest:request_dose3 delegate:self];
    ////
    
    UIAlertView *message = [[UIAlertView alloc] initWithTitle:@"Medication"
                                                      message:@"Your Medication report has been saved"
                                                     delegate:nil
                                            cancelButtonTitle:@"OK"
                                            otherButtonTitles:nil];
    [message show];
}


@end
