//
//  PeakFlowViewController.m
//  kid_peak_flow
//
//  Created by mixalis menesidis on 11/4/13.
//  Copyright (c) 2013 mixalis menesidis. All rights reserved.
//

#import "PeakFlowViewController.h"
#import "SimplePost.h"
#import "Task.h"

@interface PeakFlowViewController ()

@end

@implementation PeakFlowViewController
@synthesize peakFlowLabel;
@synthesize db;
@synthesize saveButton;

static NSString *kAddTask = @"http://192.168.1.107/my_tasks/add_task.php";


-(NSInteger) numberOfComponentsInPickerView:(UIPickerView *)pickerView
{
    return 3;
}

-(NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component
{
    if (component == COLUMN1)
    {
        return [arrayColumn1 count];
    }
    if (component == COLUMN2)
    {
        return [arrayColumn2 count];
    }
    if (component == COLUMN3)
    {
        return [arrayColumn3 count];
    }
    return 0;
}

-(NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component
{
    if (component == COLUMN1)
    {
        return [arrayColumn1 objectAtIndex:row];
    }
    if (component == COLUMN2)
    {
        return [arrayColumn2 objectAtIndex:row];
    }
    if (component == COLUMN3)
    {
        return [arrayColumn3 objectAtIndex:row];
    }
}

-(void) pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component
{
    peakFlowLabel.text = [NSString stringWithFormat:@"%@%@%@", [arrayColumn1 objectAtIndex:[pickerView selectedRowInComponent:0]], [arrayColumn2 objectAtIndex:[pickerView selectedRowInComponent:1]],[arrayColumn3 objectAtIndex:[pickerView selectedRowInComponent:2]]];
    //[arrayColumn1 objectAtIndex:[pickerView selectedRowInComponent:0]];
    
}

//------
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{

    
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    arrayColumn1 = [[NSMutableArray alloc] init];
    [arrayColumn1 addObject:@"0"];
    [arrayColumn1 addObject:@"1"];
    [arrayColumn1 addObject:@"2"];
    [arrayColumn1 addObject:@"3"];
    [arrayColumn1 addObject:@"4"];
    [arrayColumn1 addObject:@"5"];
    [arrayColumn1 addObject:@"6"];
    [arrayColumn1 addObject:@"7"];
    [arrayColumn1 addObject:@"8"];
    [arrayColumn1 addObject:@"9"];
    

    arrayColumn2 = [[NSMutableArray alloc] init];
    arrayColumn3 = [[NSMutableArray alloc] init];
    
    [arrayColumn2 addObjectsFromArray: arrayColumn1];
    [arrayColumn3 addObjectsFromArray: arrayColumn1];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillDisappear:animated];
   [[self navigationController] setNavigationBarHidden:NO animated:NO];
    
    saveButton = [[UIBarButtonItem alloc]initWithTitle:@"Save" style:UIBarButtonItemStyleBordered target:self action:@selector(saveEntry:)];

    [[self navigationItem] setRightBarButtonItem:saveButton];
    self.navigationItem.title = @"Peak Flow Meter";
    self.navigationController.navigationBar.backItem.title = @"Back";
}

-(IBAction)saveEntry:(id)sender{
    db = [[database alloc] init];
  /*
    NSMutableArray *tempSwitches = [[NSMutableArray alloc]init];
    NSInteger nSections = [self.symptomsTable numberOfSections];
    NSString *tempBool;
    for (int j=0; j<nSections; j++) {
        NSInteger nRows = [self.symptomsTable numberOfRowsInSection:j];
        for (int i=0; i<nRows; i++) {
            NSIndexPath *indexPath = [NSIndexPath indexPathForRow:i inSection:j];
            
            
            
            UITableViewCell *cell = [self.symptomsTable cellForRowAtIndexPath:indexPath];
            
            UISwitch *switches = [[UISwitch alloc] initWithFrame:(CGRectZero)];
            //switches = (UISwitch *)[self.symptomsTable cellForRowAtIndexPath:indexPath].accessoryView ;
            
            switches = (UISwitch *)cell.accessoryView;
            if(switches.on)
                tempBool = @"YES";
            else
                tempBool= @"NO";
            
            [tempSwitches addObject:tempBool];
            //  NSLog(tempBool);
        }
    }
    
    
    NSLog(@"%@",[tempSwitches objectAtIndex:0] );
   
    */
     NSLog(peakFlowLabel.text);
    // DATE
    NSDate *now = [NSDate date];
    NSCalendar *calendar = [[NSCalendar alloc] initWithCalendarIdentifier:NSGregorianCalendar];
    NSDateComponents *components = [calendar components:NSYearCalendarUnit|NSMonthCalendarUnit|NSDayCalendarUnit fromDate:now];
    [components setHour:10];
    NSDate *today10am = [calendar dateFromComponents:components];
    
    
   // [db updateSymptoms:[NSNumber numberWithDouble:[ today10am timeIntervalSinceReferenceDate]] :[tempSwitches objectAtIndex:0]:[tempSwitches objectAtIndex:1] :[tempSwitches objectAtIndex:2] :[tempSwitches objectAtIndex:3] :[tempSwitches objectAtIndex:4]];
    
    [db updatePeakFlow:[NSNumber numberWithDouble:[ today10am timeIntervalSinceReferenceDate]]:peakFlowLabel.text];
    
    Task *userID = [[Task alloc] initWithName:@"1"];
    NSMutableURLRequest *request_userID = [SimplePost urlencodedRequestWithURL:[NSURL URLWithString:kAddTask] andDataDictionary:[userID toDictionary:@"userID"]];
    [[NSURLConnection alloc] initWithRequest:request_userID delegate:self];
    
    Task *peakFlow = [[Task alloc] initWithName:peakFlowLabel.text];
    NSMutableURLRequest *request_peakFlow = [SimplePost urlencodedRequestWithURL:[NSURL URLWithString:kAddTask] andDataDictionary:[peakFlow toDictionary:@"peak"]];
    [[NSURLConnection alloc] initWithRequest:request_peakFlow delegate:self];

    
    //NSNumber *duration = self.movie.duration;
    UIAlertView *message = [[UIAlertView alloc] initWithTitle:@"PeakFlow"
                                                      message:@"Your peak flow report has been saved"
                                                     delegate:nil
                                            cancelButtonTitle:@"OK"
                                            otherButtonTitles:nil];
    [message show];
}@end
